; NOP Macro
; cod/HackingTeam
; Metastasi 0.1

%macro m_push 1
	%ifdef DEBUG_PROTO
		push %1
	%else
		%%init_:
			push %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_pop 1
	%ifdef DEBUG_PROTO
		pop %1
	%else
		%%init_:
			pop %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_mov 2
	%ifdef DEBUG_PROTO
		mov %1, %2
	%else
		%%init_:
			mov %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_add 2
	%ifdef DEBUG_PROTO
		add %1, %2
	%else
		%%init_:
			add %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_inc 1
	%ifdef DEBUG_PROTO
		inc %1
	%else
		%%init_:
			inc %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_dec 1
	%ifdef DEBUG_PROTO
		dec %1
	%else
		%%init_:
			dec %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_sub 2
	%ifdef DEBUG_PROTO
		sub %1, %2
	%else
		%%init_:
			sub %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_rep 1
	%ifdef DEBUG_PROTO
		rep %1
	%else
		%%init_:
			rep %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_call 1
	%ifdef DEBUG_PROTO
		call %1
	%else
		%%init_:
			call %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_instr 1
	%ifdef DEBUG_PROTO
		%1
	%else
		%%init_:
			%1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_cmp 2
	%ifdef DEBUG_PROTO
		cmp %1, %2
	%else
		%%init_:
			cmp %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_ja 1
	%ifdef DEBUG_PROTO
		ja near %1
	%else
		%%init_:
			ja near %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_jz 1
	%ifdef DEBUG_PROTO
		jz near %1
	%else
		%%init_:
			jz near %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_xor 2
	%ifdef DEBUG_PROTO
		xor %1, %2
	%else
		%%init_:
			xor %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_or 2
	%ifdef DEBUG_PROTO
		or %1, %2
	%else
		%%init_:
			or %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_and 2
	%ifdef DEBUG_PROTO
		and %1, %2
	%else
		%%init_:
			and %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_idiv 1
	%ifdef DEBUG_PROTO
		idiv %1
	%else
		%%init_:
			idiv %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_jmp 1
	%ifdef DEBUG_PROTO
		jmp %1
	%else
		%%init_:
			jmp near %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_jnz 1
	%ifdef DEBUG_PROTO
		jnz near %1
	%else
		%%init_:
			jnz near %1
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_test 2
	%ifdef DEBUG_PROTO
		test %1, %2
	%else
		%%init_:
			test %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_shr 2
	%ifdef DEBUG_PROTO
		shr %1, %2
	%else
		%%init_:
			shr %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_shl 2
	%ifdef DEBUG_PROTO
		shl %1, %2
	%else
		%%init_:
			shl %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro m_movzx 2
	%ifdef DEBUG_PROTO
		movzx %1, %2
	%else
		%%init_:
			movzx %1, %2
		%%end_:
			resb 10 - (%%end_ - %%init_)
	%endif
%endmacro

%macro INT03 0
	%ifdef DEBUG_PROTO
		int 3
	%endif
%endmacro

